/***********************************************
 *
 * Angelscript Dumper v2.1 by learn_more
 * File: out\a163\script\cam_dump.as
 * Generated: 08-Jan-2012 15:28:16
 * Overgrowth.exe base: 0x400000
 *
 ***********************************************/

#include "shared_dump.as"


/***********************************************
 * Files that can access these (and included) functions/objects/properties:
 */

	// cam.as


/***********************************************
 * Global Functions:
 */

vec3 __cdecl LineLineIntersect(vec3,vec3,vec3,vec3)			// 'Overgrowth.exe' + 0x368770 (0x768770)


/***********************************************
 * Objects:
 */

class CollisionPoint
{		// size: 0x1c, flags:  asOBJ_VALUE asOBJ_POD asOBJ_APP_CLASS
	vec3 position;		// byteOffset: 0x0
	vec3 normal;		// byteOffset: 0xc
	int id;		// byteOffset: 0x18
};

class SphereCollision
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	float radius;		// byteOffset: 0x0
	vec3 position;		// byteOffset: 0x4
	vec3 adjusted_position;		// byteOffset: 0x10
//-----
	int NumContacts();		// 'Overgrowth.exe' + 0xb7320 (0x4b7320)
	CollisionPoint GetContact(int);		// 'Overgrowth.exe' + 0xb7350 (0x4b7350)
};

class ASCollisions
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	vec3 GetSlidingCapsuleCollision(vec3,vec3,float);		// 'Overgrowth.exe' + 0x368bf0 (0x768bf0)
	void GetSlidingSphereCollision(vec3,float);		// 'Overgrowth.exe' + 0x369330 (0x769330)
	void GetScaledSphereCollision(vec3,float,vec3);		// 'Overgrowth.exe' + 0x3690c0 (0x7690c0)
	void GetScaledSpherePlantCollision(vec3,float,vec3);		// 'Overgrowth.exe' + 0x368fb0 (0x768fb0)
	void GetSlidingScaledSphereCollision(vec3,float,vec3);		// 'Overgrowth.exe' + 0x369390 (0x769390)
	void GetCylinderCollision(vec3,float,float);		// 'Overgrowth.exe' + 0x368e80 (0x768e80)
	void GetSweptSphereCollision(vec3,vec3,float);		// 'Overgrowth.exe' + 0x368ba0 (0x768ba0)
	void GetSweptSphereCollisionCharacters(vec3,vec3,float);		// 'Overgrowth.exe' + 0x369360 (0x769360)
	void GetSweptCylinderCollision(vec3,vec3,float,float);		// 'Overgrowth.exe' + 0x368c20 (0x768c20)
	void GetSweptBoxCollision(vec3,vec3,vec3);		// 'Overgrowth.exe' + 0x368d50 (0x768d50)
	void CheckRayCollisionCharacters(vec3,vec3);		// 'Overgrowth.exe' + 0x3687c0 (0x7687c0)
	vec3 GetRayCollision(vec3,vec3);		// 'Overgrowth.exe' + 0x3682c0 (0x7682c0)
};

class GUI
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	uint32 AddGUI(string, string, int, int, uint8);		// 'Overgrowth.exe' + 0x210830 (0x610830)
	void RemoveGUI(uint32);		// 'Overgrowth.exe' + 0x20dd00 (0x60dd00)
	void CallFunction(uint32, string);		// 'Overgrowth.exe' + 0x20dd60 (0x60dd60)
	string GetCallback(uint32);		// 'Overgrowth.exe' + 0x20eb40 (0x60eb40)
	void Update();		// 'Overgrowth.exe' + 0x211c40 (0x611c40)
};

class CameraObject
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	bool controlled;		// byteOffset: 0x84
	vec3 position;		// byteOffset: 0x88
	bool frozen;		// byteOffset: 0xd4
	vec3 velocity;		// byteOffset: 0xd8
	bool ignore_mouse_input;		// byteOffset: 0xe8
//-----
	void LoadParallaxScene(string, string);		// 'Overgrowth.exe' + 0x264e00 (0x664e00)
	void UnloadParallaxScene();		// 'Overgrowth.exe' + 0x264db0 (0x664db0)
};

class CameraAnimationReader
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	void AttachTo(string);		// 'Overgrowth.exe' + 0x32da20 (0x72da20)
	vec3 GetPosition();		// 'Overgrowth.exe' + 0x32d4a0 (0x72d4a0)
	quaternion GetRotation();		// 'Overgrowth.exe' + 0x32d460 (0x72d460)
	float GetLens();		// 'Overgrowth.exe' + 0x32d480 (0x72d480)
	void Update();		// 'Overgrowth.exe' + 0x32c620 (0x72c620)
	bool valid();		// 'Overgrowth.exe' + 0x32b9e0 (0x72b9e0)
};



/***********************************************
 * Global Properties:
 */

ASCollisions col;
SphereCollision sphere_col;
GUI gui;
uint8 _GG_IGNORES_MOUSE;		// 'Overgrowth.exe' + 0x3d6038 (0x7d6038)
CameraObject co;
CameraAnimationReader camera_animation_reader;
